#include <stdio.h>
#include <string.h>
#include <stdarg.h>
#include <stdlib.h>
#include <fcntl.h>
#include <sys/stat.h>
#include <syslog.h>
#include <unistd.h>
#include <math.h>
#include <time.h>

#include "read_iplist.h"
#include "firewall.h"
#include "shaperd_old.h"

extern int			divide_upload;
extern int			iplista_pos;
extern short			check_factor_cnt;
extern short			check_upload_factor_cnt;
extern char			iplistfile[100];
extern int			squid;
extern int			**local_int_tab2;
extern int			local_int_pos;
extern int			debug;
extern int			shaperd_counter;
extern int			class_type;
extern int			upload_class_type;
extern unsigned long int	default_download_limit;
extern unsigned long int	default_upload_limit;
extern unsigned long int	default_download_limit_hispeed;
extern unsigned long int	default_upload_limit_hispeed;
extern char			***bitrate_user_last[];
extern char			***bitrate_user_last_upload[];
extern int			last_state_perm;
extern long unsigned int       total_dnload_cir;
extern long unsigned int       total_upload_cir;

struct IPLISTA *iplista_str;

void read_iplist(char ***config)
{
    int		m,n;
    int		d1,d2,d3,d4;
    long unsigned int	d5,d6,d7,d8,d9,d10,d11,d12,d13,d14;
    int		d15,d16;
    char 	*ip, *mask;
    char	iface[10];
    char	int_iface[10];
    char	iface_t[10];
    char	int_iface_t[10];
    char	buf[30];
    char	bufor[1000];
    FILE	*fp;

    m = numlines(iplistfile) + 1;
    iplista_str = (struct IPLISTA *) calloc(m,sizeof(struct IPLISTA));
    
    iplista_pos = 1;
    fp = fopen(iplistfile,"r");
    while ((fgets(bufor,1000,fp)) != NULL)
    {
	if (bufor[0] != '#' && strlen(bufor)>7)
	{
	    d5 = 0;
	    d6 = 0;
	    d7 = 0;
	    d8 = 0;
	    d9 = 0;
	    d10 = 0;
	    d11 = 0;
	    d12 = 0;
	    d13 = 0;
	    d14 = 0;
	    d15 = 0;
	    d16 = 0;
	    if (strchr(bufor,'/'))
	    {
		char 	*iface2;
	
	        ip = strtok(bufor,"/");
		mask = strtok(NULL,"=");
	        iface2= strtok(NULL,"\n");
		sscanf(iface2,"%s %s %lu %lu %lu %lu %lu %lu %lu %lu %lu %lu %d %d",
			iface_t,int_iface_t,&d5,&d6,&d7,&d8,&d9,&d10,&d11,&d12,&d13,&d14,&d15,&d16);
	        sprintf(buf,"%s/%s",ip,mask);
	    }
	    else
	    {
	        sscanf(bufor,"%3d.%3d.%3d.%3d=%s %s %lu %lu %lu %lu %lu %lu %lu %lu %lu %lu %d %d\n",
			&d1,&d2,&d3,&d4,iface_t,int_iface_t,&d5,&d6,&d7,&d8,&d9,&d10,&d11,&d12,&d13,&d14,&d15,&d16);
	        mask = "32";
	        sprintf(buf,"%d.%d.%d.%d/%s",d1,d2,d3,d4,mask);
	    }

	    // Jesli jest znak '-' przy nazwie interfejsu lokalnego
	    if (iface_t[0]=='-')
	    {
		char	*p = iface_t;
		int	m=0,n=0;
		
		while(p[n])
		{
		    if (p[n]!='-') iface[m++]=p[n];
		    n++;
		    if (n>8)
		    {
			iface[m]='\0';
			break;
		    }
		}
		(iplista_str+iplista_pos)->static_dnload = 1;
	    }
	    else
	    {
		strncpy(iface,iface_t,9);
		(iplista_str+iplista_pos)->static_dnload = 0;
	    }
	    // Jesli jest znak '-' przy nazwie interfejsu internetowego
	    if (int_iface_t[0]=='-')
	    {
		char	*p = int_iface_t;
		int	m=0,n=0;
		
		while(p[n])
		{
		    if (p[n]!='-') int_iface[m++]=p[n];
		    n++;
		    if (n>8)
		    {
			int_iface[m]='\0';
			break;
		    }
		}
		(iplista_str+iplista_pos)->static_upload = 1;
	    }
	    else
	    {
		strncpy(int_iface,int_iface_t,9);
		(iplista_str+iplista_pos)->static_upload = 0;
	    }
	    
	    (iplista_str+iplista_pos)->str_ip = (char *) calloc(strlen(buf)+2,sizeof(char));
	    (iplista_str+iplista_pos)->iface = (char *) calloc(strlen(iface)+2,sizeof(char));
	    (iplista_str+iplista_pos)->int_iface = (char *) calloc(strlen(int_iface)+2,sizeof(char));

	    for(n=1;n<local_int_pos;n++)
	    {
	        if (local_int_tab2[1][(n*6)+5]
	    	    && !strcmp(int_iface,config[1][(n*6)+1])
		    && !strcmp(config[1][(n*6)+1],int_iface))
		{
		    // download
		    if (d5 == 0) d5 = local_int_tab2[1][(n*6)+1];  //lospeed
		    if (d5 > local_int_tab2[1][(n*6)+2]) d5 = local_int_tab2[1][(n*6)+2]; //lospeed
		    if (d6 == 0) d6 = local_int_tab2[1][(n*6)+2]; //hispeed
		    if (d6 > local_int_tab2[1][(n*6)+2]) d6 = local_int_tab2[1][(n*6)+2]; //hispeed
		    if (d11 == 0) d11 = d5;  //lospeed
		    if (d12 == 0)
		    {
			if (!default_download_limit_hispeed) d12 = d6 /2;  //hispeed/2
			else d12 = default_download_limit_hispeed;
		    }
		    if (d12 > d6) d12 = d6;
		    if (d12 < d11) d12 = d11;
		    if (d15 < 0) d15 = 0;
		    if (d15 > 7) d15 = 0;
		    if (d9 == 0) d9 = default_download_limit;
		    if (d9 == 1) d9 = 0; // jesli 1 - wylaczamy limit
		    if (d9 < 0) d9 = 0;
		    // upload
		    if (d7 == 0) d7 = local_int_tab2[1][(n*6)+3];  //lospeed
		    if (d7 > local_int_tab2[1][(n*6)+4]) d7 = local_int_tab2[1][(n*6)+4]; //lospeed
		    if (d8 == 0) d8 = local_int_tab2[1][(n*6)+4]; //hispeed
		    if (d8 > local_int_tab2[1][(n*6)+4]) d8 = local_int_tab2[1][(n*6)+4]; //hispeed
		    if (d13 == 0) d13 = d7;  //lospeed
		    if (d14 == 0)
		    {
			if (!default_upload_limit_hispeed) d14 = d8 / 2;
			else d14 = default_upload_limit_hispeed;
		    }
		    if (d14 > d8) d12 = d8;
		    if (d14 < d13) d14 = d13;
		    if (d16 < 0) d16 = 0;
		    if (d16 > 7) d16 = 0;
		    if (d10 == 0) d10 = default_upload_limit;
		    if (d10 == 1) d10 = 0; // jesli 1 - wylaczamy limit
		    if (d10 < 0) d10 = 0;
		    (iplista_str+iplista_pos) -> max_hi = local_int_tab2[1][(n*6)+2];
		    (iplista_str+iplista_pos) -> max_hi_upload = local_int_tab2[1][(n*6)+4];
		}
	    }
	    (iplista_str+iplista_pos) -> lo = d5;
	    (iplista_str+iplista_pos) -> hi = d6;
	    (iplista_str+iplista_pos) -> limit = d9;
	    (iplista_str+iplista_pos) -> limit_lo = d11;
	    (iplista_str+iplista_pos) -> limit_hi = d12;
	    (iplista_str+iplista_pos) -> prio = d15;
	    (iplista_str+iplista_pos) -> lo_upload = d7;
	    (iplista_str+iplista_pos) -> hi_upload = d8;
	    (iplista_str+iplista_pos) -> limit_upload = d10;
	    (iplista_str+iplista_pos) -> limit_lo_upload = d13;
	    (iplista_str+iplista_pos) -> limit_hi_upload = d14;
	    (iplista_str+iplista_pos) -> prio_upload = d16;

	    (iplista_str+iplista_pos) -> refresh = 0;
	    (iplista_str+iplista_pos) -> refresh_upload = 0;
	    (iplista_str+iplista_pos) -> is_overlimit = 0;
	    (iplista_str+iplista_pos) -> is_overlimit_upload = 0;
	    (iplista_str+iplista_pos) -> is_shtb_overlimit = 0;
	    (iplista_str+iplista_pos) -> is_shtb_overlimit_upload = 0;
	    (iplista_str+iplista_pos) -> shtb_refresh = 0;
	    (iplista_str+iplista_pos) -> shtb_refresh_upload = 0;

	    (iplista_str+iplista_pos) -> feir = 1;
	    (iplista_str+iplista_pos) -> feir_upload = 1;
	    
	    strcpy((iplista_str+iplista_pos) -> str_ip,buf);
	    (iplista_str+iplista_pos) -> ip = ip2hex2(buf);
	    (iplista_str+iplista_pos) -> factor = 100;
	    (iplista_str+iplista_pos) -> upload_factor = 100;
	    (iplista_str+iplista_pos) -> factor_cnt = check_factor_cnt;
	    (iplista_str+iplista_pos) -> upload_factor_cnt = check_upload_factor_cnt;
	    (iplista_str+iplista_pos) -> mask = mask2hex2(mask);
	    (iplista_str+iplista_pos) -> bool = 0;
	    if (divide_upload) (iplista_str+iplista_pos) -> bool_upload = 0;
	    strcpy((iplista_str+iplista_pos) -> iface,iface);
	    strcpy((iplista_str+iplista_pos) -> int_iface,int_iface);
	    if (debug > 1)
	    {
		printf("read_iplist: %s %s %s %lu %lu %lu %lu %lu %lu %lu %lu %lu %lu %o %o\n",
		    (iplista_str+iplista_pos) -> str_ip,
		    (iplista_str+iplista_pos) -> iface,
		    (iplista_str+iplista_pos) -> int_iface,
		    d5,d6,d7,d8,d9,d10,d11,d12,d13,d14,d15,d16);
	    }
	    iplista_pos++;
	}
    }
    fclose(fp);
}

void free_iplist(void)
{
    int		m;

    for(m=1;m<iplista_pos;m++)
    {
//	printf("(iplista_str+%d)->str_ip=%s (iplista_str+%d)->ip=%x\n",m,(iplista_str+m)->str_ip,m,(iplista_str+m)->ip);
        free((iplista_str+m)->str_ip);
        free((iplista_str+m)->iface);
        free((iplista_str+m)->int_iface);
    }
    free(iplista_str);
}

void reload_iplist(char ***config)
{
    int		m,n;
    int		d1,d2,d3,d4;
    long unsigned int	d5,d6,d7,d8,d9,d10,d11,d12,d13,d14;
    int		d15,d16;
    int		add=0;
    int		sub=0;
    int		chg=0;
    char 	*ip, *mask;
    char	iface[10];
    char	int_iface[10];
    char	iface_t[10];
    char	int_iface_t[10];
    char	buf[30];
    char	bufor[1000];
    FILE	*fp;
    int		fin = 0;
    int		iplista_pos_new;
    struct	IPLISTA	*iplista_str_new, *ptr, *ptr2;

    m = numlines(iplistfile) + 1;
    iplista_str_new = (struct IPLISTA *) calloc(m,sizeof(struct IPLISTA));
    
    iplista_pos_new = 1;
    fp = fopen(iplistfile,"r");
    while ((fgets(bufor,1000,fp)) != NULL)
    {
	if (bufor[0] != '#' && strlen(bufor)>7)
	{
	    d5 = 0;
	    d6 = 0;
	    d7 = 0;
	    d8 = 0;
	    d9 = 0;
	    d10 = 0;
	    d11 = 0;
	    d12 = 0;
	    d13 = 0;
	    d14 = 0;
	    d15 = 0;
	    d16 = 0;
	    if (strchr(bufor,'/'))
	    {
		char 	*iface2;
	
	        ip = strtok(bufor,"/");
		mask = strtok(NULL,"=");
	        iface2= strtok(NULL,"\n");
		sscanf(iface2,"%s %s %lu %lu %lu %lu %lu %lu %lu %lu %lu %lu %d %d",
			iface_t,int_iface_t,&d5,&d6,&d7,&d8,&d9,&d10,&d11,&d12,&d13,&d14,&d15,&d16);
	        sprintf(buf,"%s/%s",ip,mask);
	    }
	    else
	    {
	        sscanf(bufor,"%3d.%3d.%3d.%3d=%s %s %lu %lu %lu %lu %lu %lu %lu %lu %lu %lu %d %d\n",
			&d1,&d2,&d3,&d4,iface_t,int_iface_t,&d5,&d6,&d7,&d8,&d9,&d10,&d11,&d12,&d13,&d14,&d15,&d16);
	        mask = "32";
	        sprintf(buf,"%d.%d.%d.%d/%s",d1,d2,d3,d4,mask);
	    }

	    // Jesli jest znak '-' przy nazwie interfejsu lokalnego
	    if (iface_t[0]=='-')
	    {
		char	*p = iface_t;
		int	m=0,n=0;
		
		while(p[n])
		{
		    if (p[n]!='-') iface[m++]=p[n];
		    n++;
		    if (n>8)
		    {
			iface[m]='\0';
			break;
		    }
		}
		(iplista_str+iplista_pos_new)->static_dnload = 1;
	    }
	    else
	    {
		strncpy(iface,iface_t,9);
		(iplista_str+iplista_pos_new)->static_dnload = 0;
	    }

	    // Jesli jest znak '-' przy nazwie interfejsu internetowego
	    if (int_iface_t[0]=='-')
	    {
		char	*p = int_iface_t;
		int	m=0,n=0;
		
		while(p[n])
		{
		    if (p[n]!='-') int_iface[m++]=p[n];
		    n++;
		    if (n>8)
		    {
			int_iface[m]='\0';
			break;
		    }
		}
		(iplista_str+iplista_pos_new)->static_upload = 1;
	    }
	    else
	    {
		strncpy(int_iface,int_iface_t,9);
		(iplista_str+iplista_pos_new)->static_upload = 0;
	    }

	    for(m=1;m<iplista_pos;m++)
	    {
		ptr = iplista_str + m;
		if (!strcmp(ptr -> str_ip,buf) && !strcmp(buf,ptr -> str_ip))
		{
		    fin = 1;
		    break;
		}
	    }

	    (iplista_str_new+iplista_pos_new)->str_ip = (char *) calloc(strlen(buf)+2,sizeof(char));
	    (iplista_str_new+iplista_pos_new)->iface = (char *) calloc(strlen(iface)+2,sizeof(char));
	    (iplista_str_new+iplista_pos_new)->int_iface = (char *) calloc(strlen(int_iface)+2,sizeof(char));

	    for(n=1;n<local_int_pos;n++)
	    {
    		if (local_int_tab2[1][(n*6)+5]
    		    && !strcmp(int_iface,config[1][(n*6)+1])
		    && !strcmp(config[1][(n*6)+1],int_iface))
		{
		    // download
		    if (d5 == 0) d5 = local_int_tab2[1][(n*6)+1];  //lospeed
		    if (d5 > local_int_tab2[1][(n*6)+2]) d5 = local_int_tab2[1][(n*6)+2]; //lospeed
		    if (d6 == 0) d6 = local_int_tab2[1][(n*6)+2]; //hispeed
		    if (d6 > local_int_tab2[1][(n*6)+2]) d6 = local_int_tab2[1][(n*6)+2]; //hispeed
		    if (d11 == 0) d11 = d5;  //lospeed
		    if (d12 == 0)
		    {
			if (!default_download_limit_hispeed) d12 = d6 /2;  //hispeed/2
			else d12 = default_download_limit_hispeed;
		    }
		    if (d12 > d6) d12 = d6;
		    if (d12 == 0) d12 = default_download_limit_hispeed;  //hispeed/2
		    if (d12 < d11) d12 = d11;
		    if (d15 < 0) d15 = 0;
		    if (d15 > 7) d15 = 0;
		    if (d9 == 0) d9 = default_download_limit;
		    if (d9 == 1) d9 = 0; // jesli 1 - wylaczamy limit
		    if (d9 < 0) d9 = 0;
		    // upload
		    if (d7 == 0) d7 = local_int_tab2[1][(n*6)+3];  //lospeed
		    if (d7 > local_int_tab2[1][(n*6)+4]) d7 = local_int_tab2[1][(n*6)+4]; //lospeed
		    if (d8 == 0) d8 = local_int_tab2[1][(n*6)+4]; //hispeed
		    if (d8 > local_int_tab2[1][(n*6)+4]) d8 = local_int_tab2[1][(n*6)+4]; //hispeed
		    if (d13 == 0) d13 = d7;  //lospeed
		    if (d14 == 0)
		    {
			if (!default_upload_limit_hispeed) d14 = d8 / 2;
			else d14 = default_upload_limit_hispeed;
		    }
		    if (d14 > d8) d12 = d8;
		    if (d14 < d13) d14 = d13;
		    if (d16 < 0) d16 = 0;
		    if (d16 > 7) d16 = 0;
		    if (d10 == 0) d10 = default_upload_limit;
		    if (d10 == 1) d10 = 0; // jesli 1 - wylaczamy limit
		    if (d10 < 0) d10 = 0;
		    (iplista_str_new+iplista_pos_new) -> max_hi = local_int_tab2[1][(n*6)+2];
		    (iplista_str_new+iplista_pos_new) -> max_hi_upload = local_int_tab2[1][(n*6)+4];
		}
	    }
	    (iplista_str_new+iplista_pos_new) -> lo = d5;
	    (iplista_str_new+iplista_pos_new) -> hi = d6;
	    (iplista_str_new+iplista_pos_new) -> limit = d9;
	    (iplista_str_new+iplista_pos_new) -> limit_lo = d11;
	    (iplista_str_new+iplista_pos_new) -> limit_hi = d12;
	    (iplista_str_new+iplista_pos_new) -> prio = d15;
	    (iplista_str_new+iplista_pos_new) -> lo_upload = d7;
    	    (iplista_str_new+iplista_pos_new) -> hi_upload = d8;
	    (iplista_str_new+iplista_pos_new) -> limit_upload = d10;
	    (iplista_str_new+iplista_pos_new) -> limit_lo_upload = d13;
	    (iplista_str_new+iplista_pos_new) -> limit_hi_upload = d14;
	    (iplista_str_new+iplista_pos_new) -> prio_upload = d16;

	    (iplista_str_new+iplista_pos_new) -> refresh = 0;
	    (iplista_str_new+iplista_pos_new) -> refresh_upload = 0;
	    (iplista_str_new+iplista_pos_new) -> is_overlimit = 0;
	    (iplista_str_new+iplista_pos_new) -> is_overlimit_upload = 0;
	    (iplista_str_new+iplista_pos_new) -> is_shtb_overlimit = 0;
	    (iplista_str_new+iplista_pos_new) -> is_shtb_overlimit_upload = 0;
	    (iplista_str_new+iplista_pos_new) -> shtb_refresh = 1;
	    (iplista_str_new+iplista_pos_new) -> shtb_refresh_upload = 1;
	    (iplista_str_new+iplista_pos_new) -> feir = 1;
	    (iplista_str_new+iplista_pos_new) -> feir_upload = 1;

	    strcpy((iplista_str_new+iplista_pos_new) -> str_ip,buf);
	    (iplista_str_new+iplista_pos_new) -> ip = ip2hex2(buf);
	    (iplista_str_new+iplista_pos_new) -> mask = mask2hex2(mask);
	    strcpy((iplista_str_new+iplista_pos_new) -> iface,iface);
	    strcpy((iplista_str_new+iplista_pos_new) -> int_iface,int_iface);

	    if (!fin)
	    {
		if (debug > 1)
		{
		    printf("debug: found new line(s) in iplist file\n");
		}
		(iplista_str_new+iplista_pos_new) -> refresh = 0;
		(iplista_str_new+iplista_pos_new) -> refresh_upload = 0;
	        (iplista_str_new+iplista_pos_new) -> factor = 100;
	        (iplista_str_new+iplista_pos_new) -> upload_factor = 100;
	        (iplista_str_new+iplista_pos_new) -> factor_cnt = check_factor_cnt;
	        (iplista_str_new+iplista_pos_new) -> upload_factor_cnt = check_upload_factor_cnt;
	        (iplista_str_new+iplista_pos_new) -> bool = 0;
	        (iplista_str_new+iplista_pos_new) -> bool_upload = 0;
		(iplista_str_new+iplista_pos_new) -> ipspeed = 0;
		(iplista_str_new+iplista_pos_new) -> ipspeed_upload = 0;
		(iplista_str_new+iplista_pos_new) -> iptime = (long unsigned int) time(NULL);
		(iplista_str_new+iplista_pos_new) -> iptime_upload = (long unsigned int) time(NULL);
		(iplista_str_new+iplista_pos_new) -> ipspeed_last = 0;
		(iplista_str_new+iplista_pos_new) -> ipspeed_last_upload = 0;
		(iplista_str_new+iplista_pos_new) -> ipspeed_last2 = 0;
		(iplista_str_new+iplista_pos_new) -> ipspeed_last2_upload = 0;
		(iplista_str_new+iplista_pos_new) -> ipspeed_last2_counter = 0;
		(iplista_str_new+iplista_pos_new) -> ipspeed_last2_counter_upload = 0;
		(iplista_str_new+iplista_pos_new) -> iptime_last = (long unsigned int) time(NULL);
		(iplista_str_new+iplista_pos_new) -> iptime_last_upload = (long unsigned int) time(NULL);
		(iplista_str_new+iplista_pos_new) -> squid_speed = 0;
		(iplista_str_new+iplista_pos_new) -> squid_time = (long unsigned int) time(NULL);
		(iplista_str_new+iplista_pos_new) -> squid_speed_last = 0;
		(iplista_str_new+iplista_pos_new) -> squid_speed_last2 = 0;
		(iplista_str_new+iplista_pos_new) -> squid_time_last = (long unsigned int) time(NULL);
		(iplista_str_new+iplista_pos_new) -> is_overlimit = 0;
		(iplista_str_new+iplista_pos_new) -> is_overlimit_upload = 0;
		(iplista_str_new+iplista_pos_new) -> state_ipspeed_last = 0;
		(iplista_str_new+iplista_pos_new) -> state_squid_speed_last = 0;
		(iplista_str_new+iplista_pos_new) -> state_ipspeed_last_upload = 0;
		(iplista_str_new+iplista_pos_new) -> static_dnload = 0;
		(iplista_str_new+iplista_pos_new) -> static_upload = 0;
	    }
	    else
	    {
		fin = 0;
//		(iplista_str_new+iplista_pos_new) -> factor = ptr -> factor;
//		(iplista_str_new+iplista_pos_new) -> upload_factor = ptr -> upload_factor;
		(iplista_str_new+iplista_pos_new) -> refresh = 0;
		(iplista_str_new+iplista_pos_new) -> refresh_upload = 0;
	        (iplista_str_new+iplista_pos_new) -> factor = 100;
	        (iplista_str_new+iplista_pos_new) -> upload_factor = 100;
		(iplista_str_new+iplista_pos_new) -> factor_cnt = ptr -> factor_cnt;
		(iplista_str_new+iplista_pos_new) -> upload_factor_cnt = ptr -> upload_factor_cnt;
		(iplista_str_new+iplista_pos_new) -> bool = ptr -> bool;
		(iplista_str_new+iplista_pos_new) -> bool_upload = ptr -> bool_upload;
		(iplista_str_new+iplista_pos_new) -> ipspeed = ptr -> ipspeed;
		(iplista_str_new+iplista_pos_new) -> ipspeed_upload = ptr -> ipspeed_upload;
		(iplista_str_new+iplista_pos_new) -> iptime = ptr -> iptime;
		(iplista_str_new+iplista_pos_new) -> iptime_upload = ptr -> iptime_upload;
		(iplista_str_new+iplista_pos_new) -> ipspeed_last = ptr -> ipspeed_last;
		(iplista_str_new+iplista_pos_new) -> ipspeed_last_upload = ptr -> ipspeed_last_upload;
		(iplista_str_new+iplista_pos_new) -> ipspeed_last2 = ptr -> ipspeed_last2;
		(iplista_str_new+iplista_pos_new) -> ipspeed_last2_upload = ptr -> ipspeed_last2_upload;
		(iplista_str_new+iplista_pos_new) -> ipspeed_last2_counter = ptr -> ipspeed_last2_counter;
		(iplista_str_new+iplista_pos_new) -> ipspeed_last2_counter_upload = ptr -> ipspeed_last2_counter_upload;
		(iplista_str_new+iplista_pos_new) -> iptime_last = ptr -> iptime_last;
		(iplista_str_new+iplista_pos_new) -> iptime_last_upload = ptr -> iptime_last_upload;
		(iplista_str_new+iplista_pos_new) -> squid_speed = ptr -> squid_speed;
		(iplista_str_new+iplista_pos_new) -> squid_time = ptr -> squid_time;
		(iplista_str_new+iplista_pos_new) -> squid_speed_last = ptr -> squid_speed_last;
		(iplista_str_new+iplista_pos_new) -> squid_speed_last2 = ptr -> squid_speed_last2;
		(iplista_str_new+iplista_pos_new) -> squid_time_last = ptr -> squid_time_last;
		(iplista_str_new+iplista_pos_new) -> is_overlimit = ptr -> is_overlimit;
		(iplista_str_new+iplista_pos_new) -> is_overlimit_upload = ptr -> is_overlimit_upload;
		(iplista_str_new+iplista_pos_new) -> state_ipspeed_last = ptr -> state_ipspeed_last;
		(iplista_str_new+iplista_pos_new) -> state_squid_speed_last = ptr -> state_squid_speed_last;
		(iplista_str_new+iplista_pos_new) -> state_ipspeed_last_upload = ptr -> state_ipspeed_last_upload;
		(iplista_str_new+iplista_pos_new) -> static_dnload = ptr -> static_dnload;
		(iplista_str_new+iplista_pos_new) -> static_upload = ptr -> static_upload;
	    }

	    if (debug > 1)
	    {
		printf("reload_iplist: %s %s %s %lu %lu %lu %lu %lu %lu %lu %lu %lu %lu %o %o\n",
			(iplista_str_new+iplista_pos_new) -> str_ip,
			(iplista_str_new+iplista_pos_new) -> iface,
			(iplista_str_new+iplista_pos_new) -> int_iface,
		        d5,d6,d7,d8,d9,d10,d11,d12,d13,d14,d15,d16);
	    }
	    iplista_pos_new++;
	}
    }
    fclose(fp);

    // sprawdzamy czy cos skasowano w iplist.X
    for(m=1;m<iplista_pos;m++)
    {
	fin = 0;
	ptr = iplista_str + m;
	for(n=1;n<iplista_pos_new;n++)
	{
	    ptr2= iplista_str_new + n;
	    if (!strcmp(ptr -> str_ip,ptr2 -> str_ip) && !strcmp(ptr2 -> str_ip,ptr -> str_ip))
	    {
		fin = 1;
		break;
	    }
	}
	if (!fin)
	{
	    int		pos,int_cnt;
	    char	*intf;
	    char	*ipg;
	    int		bcn,isp;

	    if (debug > 1) printf("sub: %s\n",ptr -> str_ip);
	    sub++;
	    fin = 0;
	    del_user_from_firewall(config,ptr);
	    for(int_cnt=1;int_cnt<local_int_pos;int_cnt++)
	    {
		// jesli interfejs internetowy
		if (local_int_tab2[1][(int_cnt*6)+5])
		{
		    if ((pos = get_config_by_ip_str(config,ptr)) != -1)
    		    {
    			intf = get_ip_iface_str(ptr);
	    		bcn = atoi(config[1][(pos*6)+5]);
	    		isp = atoi(config[1][(pos*6)+2]);
		        ipg = config[1][(pos*6)+3];
	    		cbq_class_del(intf,isp,0,bcn,get_ip_cnt(ptr -> str_ip)+4,ipg,ptr -> str_ip,3,1,"",class_type,NULL);
			bitrate_user_last[int_cnt] = mkbitrate_user_last(bitrate_user_last[int_cnt],ptr -> str_ip,0,int_cnt);
		    }

		    if (divide_upload)
		    {
			if ((pos = get_config_by_ip_upload_str(config,ptr)) != -1)
		        {
		    	    intf = get_ip_int_iface_str(ptr);
		    	    bcn = atoi(config[1][(pos*6)+3]);
		    	    isp = local_int_tab2[1][(int_cnt*6)+4];
		    	    ipg = config[1][(pos*6)+3];
	    	    	    cbq_class_del_upload(intf,isp,0,bcn,get_ip_cnt(ptr -> str_ip)+4,ipg,ptr -> str_ip,3,1,"",upload_class_type,NULL);
			    bitrate_user_last_upload[int_cnt] = mkbitrate_user_last_upload(bitrate_user_last_upload[int_cnt],ptr -> str_ip,0,int_cnt);
			}
		    }
		}
	    }
	}
    }
    
    // sprawdzamy czy cos dodano
    for(m=1;m<iplista_pos_new;m++)
    {
	fin = 0;
	ptr = iplista_str_new + m;
	for(n=1;n<iplista_pos;n++)
	{
	    ptr2= iplista_str + n;
	    if (!strcmp(ptr -> str_ip,ptr2 -> str_ip) && !strcmp(ptr2 -> str_ip,ptr -> str_ip))
	    {
		fin = 1;
		break;
	    }
	}
	if (!fin)
	{
	    if (debug > 1) printf("add: %s\n",ptr -> str_ip);
	    add++;
	    fin = 0;

	    add_user_to_firewall(config,ptr,get_ip_cnt2(ptr,iplista_str_new,iplista_pos_new));
	}
    }

    // Sprawdzamy czy jakis wiersz nie rozni si miedzy starym i nowym iplist
    for(m=1;m<iplista_pos_new;m++)
    {
	fin = 0;
	ptr = iplista_str_new + m;
	for(n=1;n<iplista_pos;n++)
	{
	    ptr2= iplista_str + n;
	    if (!strcmp(ptr -> str_ip,ptr2 -> str_ip))
	    {
		if (n != m)
		{
		    fin = 1;
		    break;
		}
		else
		if (ptr -> lo != ptr2 -> lo)
		{
		    ptr -> refresh = 1;
		    total_dnload_cir = total_dnload_cir - (ptr2 -> lo - ptr -> lo);
//		    if (debug) printf("%s zmiana download CIR!\n",ptr ->str_ip);
		}
		else
		if (ptr -> lo_upload != ptr2 -> lo_upload)
		{
		    ptr -> refresh_upload = 1;
		    total_upload_cir = total_upload_cir - (ptr2 -> lo_upload - ptr -> lo_upload);
//		    if (debug) printf("%s zmiana upload CIR!\n",ptr ->str_ip);
		}
/*
		100 - (10 - 100) = 100 - (-90) = 190
		190 - (100 - 10) = 190 - 90 = 100
*/
		
	    }
	}
	if (fin)
	{
	    int		pos,int_cnt;
	    char	*intf;
	    char	*ipg;
	    int		bcn,isp;

	    chg++;
	    fin = 0;

//	    if (debug) printf("chg: m=%d n=%d iplista_pos=%d\n",m,n,iplista_pos);
	    if (m < iplista_pos)
	    {
		ptr2= iplista_str + m;
//	        if (debug) printf("chg: ptr2=%s %d -> ptr=%s %d\n",ptr2 -> str_ip,m,ptr -> str_ip,n);
//		if (debug) printf("del fr firewall %s\n",ptr2 -> str_ip);
		del_user_from_firewall(config,ptr2);
		for(int_cnt=1;int_cnt<local_int_pos;int_cnt++)
	        {
	    	    // jesli interfejs internetowy
		    if (local_int_tab2[1][(int_cnt*6)+5])
		    {
		        if ((pos = get_config_by_ip_str(config,ptr2)) != -1)
    		        {
    			    intf = get_ip_iface_str(ptr2);
	    		    bcn = atoi(config[1][(pos*6)+5]);
	    		    isp = atoi(config[1][(pos*6)+2]);
		    	    ipg = config[1][(pos*6)+3];
	    		    cbq_class_del(intf,isp,0,bcn,get_ip_cnt(ptr2 -> str_ip)+4,ipg,ptr2 -> str_ip,3,1,"",class_type,NULL);
			    bitrate_user_last[int_cnt] = mkbitrate_user_last(bitrate_user_last[int_cnt],ptr2 -> str_ip,0,int_cnt);
		        }

			if (divide_upload)
		        {
			    if ((pos = get_config_by_ip_upload_str(config,ptr2)) != -1)
		    	    {
		    		intf = get_ip_int_iface_str(ptr2);
		    	        bcn = atoi(config[1][(pos*6)+3]);
		    	        isp = local_int_tab2[1][(int_cnt*6)+4];
		    	        ipg = config[1][(pos*6)+3];
	    	    	        cbq_class_del_upload(intf,isp,0,bcn,get_ip_cnt(ptr2 -> str_ip)+4,ipg,ptr2 -> str_ip,3,1,"",upload_class_type,NULL);
			        bitrate_user_last_upload[int_cnt] = mkbitrate_user_last_upload(bitrate_user_last_upload[int_cnt],ptr2 -> str_ip,0,int_cnt);
			    }
			}
		    }
		}
	    }
	    if (n < iplista_pos_new)
	    {
//    	        if (debug) printf("add to firewall %s %d\n",ptr ->str_ip,get_ip_cnt2(ptr,iplista_str_new,iplista_pos_new));
		add_user_to_firewall(config,ptr,get_ip_cnt2(ptr,iplista_str_new,iplista_pos_new));
	    }
	}
    }

    if (chg) syslog(LOG_INFO,"Changed %d lines in %s/iplist.%d file.",chg,CONFIG_DIR,shaperd_counter);
    if (add) syslog(LOG_INFO,"Added %d lines in %s/iplist.%d file.",add,CONFIG_DIR,shaperd_counter);
    if (sub) syslog(LOG_INFO,"Removed %d lines in %s/iplist.%d file.",sub,CONFIG_DIR,shaperd_counter);

    free_iplist();
    iplista_str = iplista_str_new;
    iplista_pos = iplista_pos_new;

}

unsigned int is_file(char *name)
{
    FILE	*fp;
    
    if ((fp = fopen(name,"r")))
    {
	fclose(fp);
	return(1);
    }
    return 0;
}

void read_last_state(char *filename)
{
    int		n;
    int		d1,d2;
    long unsigned int	d3,d4,d5;
    char 	ip[30];
    char	bufor[1000];
    FILE	*fp;
    struct	IPLISTA	*ptr;

    if ((fp = fopen(filename,"r")))
    {
	while ((fgets(bufor,1000,fp)) != NULL)
	{
    	    d1 = 0;
    	    d2 = 0;
    	    d3 = 0;
    	    d4 = 0;
	    d5 = 0;

    	    sscanf(bufor,"%s %d %d %lu %lu %lu",ip,&d1,&d2,&d3,&d4,&d5);

    	    for(n=1;n<iplista_pos;n++)
    	    {
		ptr = iplista_str + n;
		if (!strcmp(ptr -> str_ip,ip) && !strcmp(ip,ptr ->str_ip))
	        {
		    ptr -> is_overlimit = d1;
		    ptr -> is_overlimit_upload = d2;
		    ptr -> state_ipspeed_last = d3;
		    ptr -> state_squid_speed_last = d4;
		    ptr -> state_ipspeed_last_upload = d5;
		    if (debug > 1)
	    	    {
			printf("read_last_state: %s %d %d %lu %lu %lu\n",
			    	ptr -> str_ip,
				ptr -> is_overlimit,
				ptr -> is_overlimit_upload,
				ptr -> state_ipspeed_last,
				ptr -> state_squid_speed_last,
				ptr -> state_ipspeed_last_upload);
		    }
		}
	    }
	}
	fclose(fp);
	remove(filename);
    }
    else
    {
	for(n=1;n<iplista_pos;n++)
    	{
	    ptr = iplista_str + n;
	    ptr -> is_overlimit = 0;
	    ptr -> is_overlimit_upload = 0;
	    ptr -> is_shtb_overlimit = 0;
	    ptr -> is_shtb_overlimit_upload = 0;
	    ptr -> state_ipspeed_last = 0;
	    ptr -> state_squid_speed_last = 0;
	    ptr -> state_ipspeed_last_upload = 0;
	}
    }
}

void write_last_state(char *filename)
{
    int		m;
    int		fd;
    char	buf[200];
    struct	IPLISTA	*ptr;

    fd = creat(filename,last_state_perm);
    for(m=1;m<iplista_pos;m++)
    {
	ptr = iplista_str + m;
	if (ptr -> ipspeed_last < ptr -> ipspeed) ptr -> ipspeed_last = ptr -> ipspeed;
	if (ptr -> squid_speed_last < ptr -> squid_speed) ptr -> squid_speed_last = ptr -> squid_speed;
	if (ptr -> state_ipspeed_last_upload < ptr -> ipspeed_last_upload) ptr -> state_ipspeed_last_upload = ptr -> ipspeed_last_upload;

	sprintf(buf,"%s %d %d %lu %lu %lu\n",
		ptr -> str_ip,
		ptr -> is_overlimit,
		ptr -> is_overlimit_upload,
		ptr -> state_ipspeed_last + ptr -> ipspeed_last,
		ptr -> state_squid_speed_last + ptr -> squid_speed_last,
		ptr -> state_ipspeed_last_upload + ptr -> ipspeed_last_upload);
	write(fd,buf,strlen(buf));
    }
    close(fd);
}
